
-- IMPORTANT: TODO: in relationship section-> create triggers that would properly set values in tables during dele or update
-- change only the lines with comments
-- Table files

CREATE TABLE [files]
(
 [id_file] Int NOT NULL,
 [id_user] Int NULL,
 [id_mimetype] Int NOT NULL,
 [url] Varchar(255) NULL,
 [name_file] Varchar(255) NOT NULL,
 [hidden] Bit DEFAULT 0 NOT NULL,
 [protected] Bit DEFAULT 0 NOT NULL,
 [encrypted] Bit DEFAULT 0 NOT NULL,
 [locked] Int NULL,
 [deleted] Bit DEFAULT 0 NOT NULL,
 [id_parent] Int NULL,
 [hash] Char(128) NULL,
 [id_files_storage] Int NOT NULL
);

-- Add keys for table files

ALTER TABLE [files] ADD CONSTRAINT [files_pk] PRIMARY KEY ([id_file]);

-- Table fpermissions

CREATE TABLE [fpermissions]
(
 [id_file] Int NOT NULL,
 [id_role] Int NOT NULL,
 [id_fprivilege] Int NOT NULL,
 [allowed] Bit DEFAULT 1 NOT NULL
);

-- Add keys for table fpermissions

ALTER TABLE [fpermissions] ADD CONSTRAINT [Key4] PRIMARY KEY ([id_fprivilege],[id_role],[id_file]);

-- Table fprivileges

CREATE TABLE [fprivileges]
(
 [id_fprivilege] Int NOT NULL,
 [name] Varchar(255) NOT NULL
);

-- Add keys for table fprivileges

ALTER TABLE [fprivileges] ADD CONSTRAINT [fprivileges_pk] PRIMARY KEY ([id_fprivilege]);

ALTER TABLE [fprivileges] ADD CONSTRAINT [name] UNIQUE ([name]);

-- Table mimetypes

CREATE TABLE [mimetypes]
(
 [id_mimetype] Int NOT NULL,
 [name_mimetype] Varchar(40) NULL
);

-- Add keys for table mimetypes

ALTER TABLE [mimetypes] ADD CONSTRAINT [mimetypes_pk] PRIMARY KEY ([id_mimetype]);

-- Table actions

CREATE TABLE [actions]
(
 [id_action] Int NOT NULL,
 [name] Varchar(40) NULL
);

-- Add keys for table actions

ALTER TABLE [actions] ADD CONSTRAINT [actions_pk] PRIMARY KEY ([id_action]);

-- Table applications

CREATE TABLE [applications]
(
 [id_application] Int NOT NULL,
 [url] Char(255) NULL,
 [name] Varchar(40) NULL,
 [publisher] Varchar(100) NULL,
 [altText] Varchar(40) NULL,
 [created] Datetime2 NOT NULL,
 [version] Varchar(12) NULL,
 [system] Bit DEFAULT 0 NOT NULL
);

-- Add keys for table applications

ALTER TABLE [applications] ADD CONSTRAINT [applications_pk] PRIMARY KEY ([id_application]);

ALTER TABLE [applications] ADD CONSTRAINT [url] UNIQUE ([url]);

ALTER TABLE [applications] ADD CONSTRAINT [name_unique] UNIQUE ([name]);

-- Table file_preferences

CREATE TABLE [file_preferences]
(
 [id_action] Int NOT NULL,
 [id_mimetype] Int NOT NULL,
 [id_application] Int NOT NULL,
 [id_user] Int NOT NULL
);

-- Add keys for table file_preferences

ALTER TABLE [file_preferences] ADD CONSTRAINT [Key9] PRIMARY KEY ([id_action],[id_mimetype],[id_application],[id_user]);

-- Table file_changes

CREATE TABLE [file_changes]
(
 [id_file_change] Int NOT NULL,
 [id_file] Int NULL,
 [time] Datetime2 NULL,
 [action] Smallint NULL,
 [id_user] Int NULL,
 [name_file] Varchar(255) NOT NULL,
 [user_name] Varchar(45) NOT NULL
);

-- Add keys for table file_changes

ALTER TABLE [file_changes] ADD CONSTRAINT [files_changes_pk] PRIMARY KEY ([id_file_change]);

-- Table files_storages

CREATE TABLE [files_storages]
(
 [id_files_storage] Int NOT NULL,
 [name_files_storage] Varchar(255) NULL
);

-- Add keys for table files_storages

ALTER TABLE [files_storages] ADD CONSTRAINT [id_files_storage] PRIMARY KEY ([id_files_storage]);

-- Table applications_users

CREATE TABLE [applications_users]
(
 [id_application] Int NOT NULL,
 [id_user] Int NOT NULL
);

-- Add keys for table applications_users

ALTER TABLE [applications_users] ADD CONSTRAINT [Key10] PRIMARY KEY ([id_application],[id_user]);

-- Create relationships section -------------------------------------------------

ALTER TABLE [files] ADD CONSTRAINT [users_files] FOREIGN KEY ([id_user]) REFERENCES [users] ([id]) ON UPDATE CASCADE ON DELETE SET NULL;

ALTER TABLE [fpermissions] ADD CONSTRAINT [files_fpermissions] FOREIGN KEY ([id_file]) REFERENCES [files] ([id_file]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [fpermissions] ADD CONSTRAINT [roles_fpermissions] FOREIGN KEY ([id_role]) REFERENCES [roles] ([id]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [fpermissions] ADD CONSTRAINT [fprivileges_fpermissions] FOREIGN KEY ([id_fprivilege]) REFERENCES [fprivileges] ([id_fprivilege]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [files] ADD CONSTRAINT [mimetypes_files] FOREIGN KEY ([id_mimetype]) REFERENCES [mimetypes] ([id_mimetype]) ON UPDATE CASCADE ON DELETE NO ACTION;

ALTER TABLE [file_preferences] ADD CONSTRAINT [actions_file_preferences] FOREIGN KEY ([id_action]) REFERENCES [actions] ([id_action]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [file_preferences] ADD CONSTRAINT [mimetypes_file_preferences] FOREIGN KEY ([id_mimetype]) REFERENCES [mimetypes] ([id_mimetype]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [file_preferences] ADD CONSTRAINT [applications_file_preferences] FOREIGN KEY ([id_application]) REFERENCES [applications] ([id_application]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [file_preferences] ADD CONSTRAINT [users_file_preferences] FOREIGN KEY ([id_user]) REFERENCES [users] ([id]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [file_changes] ADD CONSTRAINT [files_file_changes] FOREIGN KEY ([id_file]) REFERENCES [files] ([id_file]) ON UPDATE CASCADE ON DELETE SET NULL;

ALTER TABLE [file_changes] ADD CONSTRAINT [users_file_changes] FOREIGN KEY ([id_user]) REFERENCES [users] ([id]) ON UPDATE NO ACTION ON DELETE NO ACTION-- ON UPDATE CASCADE ON DELETE SET NULL; <- it must work this way

ALTER TABLE [files] ADD CONSTRAINT [users_files_lock] FOREIGN KEY ([locked]) REFERENCES [users] ([id]) ON UPDATE NO ACTION ON DELETE NO ACTION; --ON UPDATE CASCADE ON DELETE SET NULL; <- it must work this way

ALTER TABLE [files] ADD CONSTRAINT [file_parent] FOREIGN KEY ([id_parent]) REFERENCES [files] ([id_file]) ON UPDATE NO ACTION ON DELETE NO ACTION; --ON UPDATE CASCADE ON DELETE NO ACTION; <- it must work this way

ALTER TABLE [files] ADD CONSTRAINT [file_storages_files] FOREIGN KEY ([id_files_storage]) REFERENCES [files_storages] ([id_files_storage]) ON UPDATE CASCADE ON DELETE NO ACTION;

ALTER TABLE [applications_users] ADD CONSTRAINT [applications_users_applications] FOREIGN KEY ([id_application]) REFERENCES [applications] ([id_application]) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE [applications_users] ADD CONSTRAINT [applications_users_users] FOREIGN KEY ([id_user]) REFERENCES [users] ([id]) ON DELETE CASCADE ON UPDATE CASCADE;


----table [users] must be in database
--CREATE TRIGGER [users_file_changes_update_trigger]
--ON [users]
--AFTER UPDATE
--AS
--BEGIN
--END;
