-- THE ONLY WORKING MODULE NOW WITH APPS
CREATE TABLE `files`
(
  `id_file` Int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_user` Int(10) UNSIGNED,
  `id_mimetype` Int(10) UNSIGNED NOT NULL,
  `url` Varchar(255),
  `name_file` Varchar(255) NOT NULL,
  `hidden` Bool NOT NULL DEFAULT false,
  `protected` Bool NOT NULL DEFAULT false,
  `encrypted` Bool NOT NULL DEFAULT false,
  `locked` Int(10) UNSIGNED,
  `deleted` Bool NOT NULL DEFAULT false,
  `id_parent` Int(10) UNSIGNED,
  `hash` Char(128),
  `id_files_storage` Int(10) NOT NULL,
   PRIMARY KEY (`id_file`)
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

-- Table fpermissions

CREATE TABLE `fpermissions`
(
  `id_file` Int(10) UNSIGNED NOT NULL,
  `id_role` Int(10) UNSIGNED NOT NULL,
  `id_fprivilege` Int(10) UNSIGNED NOT NULL,
  `allowed` Bool NOT NULL DEFAULT true
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

ALTER TABLE `fpermissions` ADD PRIMARY KEY (`id_fprivilege`,`id_role`,`id_file`)
;

-- Table fprivileges

CREATE TABLE `fprivileges`
(
  `id_fprivilege` Int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` Varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci UNIQUE NOT NULL,
  PRIMARY KEY (`id_fprivilege`)
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

-- Table mimetypes

CREATE TABLE `mimetypes`
(
  `id_mimetype` Int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name_mimetype` Varchar(40),
  PRIMARY KEY (`id_mimetype`)
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

-- Table actions

CREATE TABLE `actions`
(
  `id_action` Int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` Varchar(40),
  PRIMARY KEY (`id_action`)
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

-- Table file_preferences

CREATE TABLE `file_preferences`
(
  `id_action` Int(10) UNSIGNED NOT NULL,
  `id_mimetype` Int(10) UNSIGNED NOT NULL,
  `id_application` Int(10) UNSIGNED NOT NULL,
  `id_user` Int(10) UNSIGNED NOT NULL
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

ALTER TABLE `file_preferences` ADD PRIMARY KEY (`id_action`,`id_mimetype`,`id_application`,`id_user`)
;

-- Table file_changes

CREATE TABLE `file_changes`
(
  `id_file_change` Int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_file` Int(10) UNSIGNED,
  `time` Datetime,
  `action` Smallint,
  `id_user` Int(10) UNSIGNED,
  `name_file` Varchar(255) NOT NULL,
  `user_name` Varchar(45) NOT NULL,
  PRIMARY KEY (`id_file_change`)
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

-- Table applications

CREATE TABLE `applications`
(
  `id_application` Int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `url` Varchar(255) NOT NULL UNIQUE ,
  `name` Varchar(40) NOT NULL UNIQUE,
  `publisher` Varchar(100),
  `altText` Varchar(40),
  `created` Datetime NOT NULL,
  `version` Varchar(12),
  `system` Bool NOT NULL DEFAULT false,
  PRIMARY KEY (`id_application`)
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;

CREATE TABLE `applications_users`
(
  `id_application` Int(10) UNSIGNED NOT NULL,
  `id_user` Int(10) UNSIGNED NOT NULL
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;
ALTER TABLE `applications_users` ADD PRIMARY KEY (`id_application`,`id_user`);

-- Table files_storages

CREATE TABLE files_storages
(
  `id_files_storage` Int(10) NOT NULL AUTO_INCREMENT,
  `name_files_storage` Varchar(255),
  PRIMARY KEY (`id_files_storage`)
) ENGINE = InnoDB
  DEFAULT CHARACTER SET utf8
  COLLATE utf8_general_ci
  ROW_FORMAT = Compact
;


-- Create relationships section -------------------------------------------------

ALTER TABLE `files` ADD CONSTRAINT `users files` FOREIGN KEY (`id_user`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE CASCADE
;

ALTER TABLE `fpermissions` ADD CONSTRAINT `files_fpermissions` FOREIGN KEY (`id_file`) REFERENCES `files` (`id_file`) ON DELETE CASCADE ON UPDATE CASCADE
;

ALTER TABLE `fpermissions` ADD CONSTRAINT `roles_fpermissions` FOREIGN KEY (`id_role`) REFERENCES `roles` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
;

ALTER TABLE `fpermissions` ADD CONSTRAINT `fprivileges_fpermissions` FOREIGN KEY (`id_fprivilege`) REFERENCES `fprivileges` (`id_fprivilege`) ON DELETE CASCADE ON UPDATE CASCADE
;

ALTER TABLE `files` ADD CONSTRAINT `mimetypes_files` FOREIGN KEY (`id_mimetype`) REFERENCES `mimetypes` (`id_mimetype`) ON DELETE RESTRICT ON UPDATE CASCADE
;

ALTER TABLE `file_preferences` ADD CONSTRAINT `actions_file_preferences` FOREIGN KEY (`id_action`) REFERENCES `actions` (`id_action`) ON DELETE CASCADE ON UPDATE CASCADE
;

ALTER TABLE `file_preferences` ADD CONSTRAINT `mimetypes_file_preferences` FOREIGN KEY (`id_mimetype`) REFERENCES `mimetypes` (`id_mimetype`) ON DELETE CASCADE ON UPDATE CASCADE
;

ALTER TABLE `file_preferences` ADD CONSTRAINT `applications_file_preferences` FOREIGN KEY (`id_application`) REFERENCES `applications` (`id_application`) ON DELETE CASCADE ON UPDATE CASCADE
;

ALTER TABLE `file_preferences` ADD CONSTRAINT `users_file_preferences` FOREIGN KEY (`id_user`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
;

ALTER TABLE `file_changes` ADD CONSTRAINT `files_file_changes` FOREIGN KEY (`id_file`) REFERENCES `files` (`id_file`) ON DELETE SET NULL ON UPDATE CASCADE
;

ALTER TABLE `file_changes` ADD CONSTRAINT `users_file_changes` FOREIGN KEY (`id_user`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE CASCADE
;

ALTER TABLE `files` ADD CONSTRAINT `users_files_lock` FOREIGN KEY (`locked`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE CASCADE
;

ALTER TABLE `files` ADD CONSTRAINT `file_parent` FOREIGN KEY (`id_parent`) REFERENCES `files` (`id_file`) ON DELETE RESTRICT ON UPDATE CASCADE
;

ALTER TABLE `applications_users` ADD CONSTRAINT `applications_users_application` FOREIGN KEY (`id_application`) REFERENCES `applications` (`id_application`) ON DELETE CASCADE ON UPDATE CASCADE
;

ALTER TABLE `applications_users` ADD CONSTRAINT `applications users user` FOREIGN KEY (`id_user`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
;
ALTER TABLE `files` ADD CONSTRAINT `file_storages_files` FOREIGN KEY (`id_files_storage`) REFERENCES `files_storages` (`id_files_storage`) ON DELETE RESTRICT ON UPDATE CASCADE
;
